<?php
/*
Plugin Name: flowplayer-wrapper
Plugin URI: http://www.ramgad.com/fpw/
Description: Including flowplayer (flowplayer.org). Call FPW (flowplayer-wrapper) by adding [fpw_videofullpath=full_http_path_to_your_video] to your content. A couple of options can be customized in the settings session. If you want to embed flickr.com slideshows, please have a look at http://www.ramgad.com/fssw/. This version has only be tested with the commercial version of flowplayer, but shall work as well with the light version.
Version: 1.0.0
Author: Jeannot Muller
Author URI: http://www.ramgad.com/
Min WP Version: 2.1
Max WP Version: 2.9
*/

// Update routines
	if ('insert' == $HTTP_POST_VARS['action']) {
    	update_option("fpw_width",$HTTP_POST_VARS['fpw_width']);
    	update_option("fpw_height",$HTTP_POST_VARS['fpw_height']);
    	update_option("fpw_license",$HTTP_POST_VARS['fpw_license']);
    	update_option("fpw_autoplay",$HTTP_POST_VARS['fpw_autoplay']);
        update_option("fpw_autobuffer",$HTTP_POST_VARS['fpw_autobuffer']);
        update_option("fpw_allowfs",$HTTP_POST_VARS['fpw_allowfs']);
        update_option("fpw_bgcolor",$HTTP_POST_VARS['fpw_bgcolor']);
        update_option("fpw_path",$HTTP_POST_VARS['fpw_path']);
}

if (!class_exists('fpw_main')) {
    class fpw_main {
		/**
		* PHP 4 Compatible Constructor
		*/
		function fpw_main(){$this->__construct();}
		
		/**
		* PHP 5 Constructor
		*/		
		function __construct(){
			// Registrieren der WordPress-Hooks
			add_action('admin_menu', 'fpw_description_add_menu');
			add_filter('the_content', 'get_flowplayer_data_parsed');
		}
		// Registration of WordPress-Hooks
	}

function fpw_description_option_page() {
	?>

	<!-- Start Options Adminarea (xhtml) -->
	  <div class="wrap">
	    <h2>Flowplayer-Wrapper Options</h2>
		         <div style="margin-top:20px;">
		         <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>&amp;updated=true">
		                          <div style="">
						<table class="form-table">
						<tr><th scope="col" colspan="3" cellpadding="15">Settings</th></tr>
		                                <tr><th scope="row">Width:</th><td>
		                    <input name="fpw_width" size="3" value="<?=get_option("fpw_width");?>" type="text" /><span style="color:red;">   Example: 480</span></td></tr>
						<tr><th scope="row">Height:</th><td>
		                    <input name="fpw_height" size="3" value="<?=get_option("fpw_height");?>" type="text" /><span style="color:red;">   Example: 272</span></td></tr>
						<tr><th scope="row">License Key:</th><td>
			            <input name="fpw_license" size="20" value="<?=get_option("fpw_license");?>" type="text" /><span style="color:red;">   Example: $xyz</span>(please use <a href="http://www.flowplayer.org/" target="_blank">flowplayer.org</a> to get a license key)</td></tr>
						<tr><th scope="row">AutoPlay (true|false):</th><td>
				    <input name="fpw_autoplay" size="5" value="<?=get_option("fpw_autoplay");?>" type="text" /><span style="color:red;">   Example: no</span></td></tr>
                                                <tr><th scope="row">AutoBuffer (true|false):</th><td>
			            <input name="fpw_autobuffer" size="5" value="<?=get_option("fpw_autobuffer");?>" type="text" /><span style="color:red;">   Example: yes</span> </td></tr>
												<tr><th scope="row">Fullscreen (true|false):</th><td>
<input name="fpw_allowfs" size="5" value="<?=get_option("fpw_allowfs");?>" type="text" /><span style="color:red;">   Example: yes</span> </td></tr>
				                <tr><th scope="row">Backgroundcolor</th><td>
			            <input name="fpw_bgcolor" size="7" value="<?=get_option("fpw_bgcolor");?>" type="text" /><span style="color:red;">   Example: #000000</span></td></tr>
                                                <tr><th scope="row">Full path to the flowplayer.xyz.swf file:</th><td>
			            <input name="fpw_path" size="60" value="<?=get_option("fpw_path");?>" type="text" /><span style="color:red;">   Example: www.ramgad.com/flowplayer/flowplayer.commercial-3.1.1.swf</span></td></tr>
</table>
	      <br>
	      <p class="submit"><input name="submit" type="submit" id="submit" value="Save changes &raquo;">
	     <input class="submit" name="action" value="insert": type="hidden" /></p>
	    </form>
	  </div>
	</div>
	<p style="text-align:justify;">Call FPW (flowplayer-wrapper) by adding [fpw_videofullpath=full_http_path_to_your_video] to your content.
	<p style="text-align:justify;">If you have problems with FPW (flowplayer-wrapper), please feel free to contact me: <a href="mailto:jeannot.muller@ramgad.com">jeannot.muller@ramgad.com</a></p>

<?php

} // Ende Funktion fssw_description_option_page()

// Adminmenu Optionen erweitern
function fpw_description_add_menu() {
      global $fpw_width, $fpw_height, $fpw_license, $fpw_autoplay, $fpw_autobuffer, $fpw_allowfs, $fpw_bgcolor, $fpw_path;
      add_options_page('FPW', 'FPW', 9, __FILE__, 'fpw_description_option_page'); //optionenseite hinzufügen
}

function get_flowplayer_data_parsed($content) {
		 $fpw_width      = get_option('fpw_width');
		 $fpw_height     = get_option('fpw_height');
		 $fpw_license    = get_option('fpw_license');
		 $fpw_autoplay   = get_option('fpw_autoplay');
		 $fpw_autobuffer = get_option('fpw_autobuffer');
		 $fpw_allowfs    = get_option('fpw_allowfs');
		 $fpw_bgcolor    = get_option('fpw_bgcolor');
		 $fpw_path       = get_option('fpw_path');

// standard initialisation (default values)	
		 if ( $fpw_width == null or $fpw_height == null) {
			$fpw_width  = "480";
		    $fpw_height = "272";		
		 }

	// parse and replace	 
	
	
$content = preg_replace('/\[fpw_videofullpath=([a-zA-Z0-9].+)\]/', '<object id="flowplayer" width="' . $fpw_width . '" height="' . $fpw_height . '" bgcolor="' . $fpw_bgcolor . '" data="' . $fpw_path . '" type="application/x-shockwave-flash"> <param name="movie" value="' . $fpw_path . '" /> <param name="allowfullscreen" value="' . $fpw_allowfs .'" /> <param name="flashvars" value=\'config={"key":"' . $fpw_license .'","clip":{"url":"$1","autoPlay":' . $fpw_autoplay . ', "autoBuffering":' . $fpw_autobuffer . '}}\' /> </object>', $content);


return $content;
   } 

}

//instantiate the class
if (class_exists('fpw_main')) {
	$fpw_main = new fpw_main();
}
?>
